SystemOrganization addCategory: #'Magritte-Core'!
SystemOrganization addCategory: #'Magritte-Core-Description'!
SystemOrganization addCategory: #'Magritte-Core-Accessor'!
SystemOrganization addCategory: #'Magritte-Core-Relation'!
SystemOrganization addCategory: #'Magritte-Core-Builder'!
SystemOrganization addCategory: #'Magritte-Core-Exception'!
SystemOrganization addCategory: #'Magritte-Core-Utility'!

ProtoObject subclass: #MAProxyObject
	instanceVariableNames: 'realSubject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAProxyObject subclass: #MADynamicObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MADynamicObject methodsFor: 'accessing' stamp: 'lr 3/10/2005 11:44'!
realSubject
	^super realSubject value.! !

!MAProxyObject class methodsFor: 'instance creation' stamp: 'lr 1/1/2005 15:58'!
on: anObject
	^self basicNew realSubject: anObject.! !

!MAProxyObject methodsFor: 'private' stamp: 'lr 2/28/2005 16:05'!
doesNotUnderstand: aMessage
	^self realSubject
		perform: aMessage selector
		withArguments: aMessage arguments.! !

!MAProxyObject methodsFor: 'testing' stamp: 'al 4/14/2005 19:02'!
isMorph
	^ false! !

!MAProxyObject methodsFor: 'testing' stamp: 'lr 2/28/2005 16:05'!
isNil
	^self realSubject isNil.! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 2/28/2005 16:05'!
printOn: aStream
	aStream nextPut: $[; print: self realSubject; nextPut: $].! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 2/28/2005 16:05'!
printString
	^String streamContents: [ :stream | self printOn: stream ].! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:05'!
realSubject
	^realSubject! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:05'!
realSubject: anObject
	realSubject := anObject! !

!UndefinedObject methodsFor: '*Magritte-Core-converting' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'n/a'! !

Error subclass: #MAError
	instanceVariableNames: 'wrapper resumable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

MAError subclass: #MAConcurrentError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

!MAError class methodsFor: 'instance creation' stamp: 'lr 4/7/2005 22:26'!
wrapper: aWrapper message: aString
	^self wrapper: aWrapper message: aString resumable: false.! !

!MAError class methodsFor: 'instance creation' stamp: 'lr 4/7/2005 22:26'!
wrapper: aWrapper message: aString resumable: aBoolean
	^self new
		wrapper: aWrapper;
		resumable: aBoolean;
		signal: aString.! !

!MAError methodsFor: 'accessing-dynamic' stamp: 'lr 4/7/2005 22:29'!
accessor
	^self wrapper accessor.! !

!MAError methodsFor: 'accessing-dynamic' stamp: 'lr 4/9/2005 00:36'!
description
	^self wrapper owner.! !

!MAError methodsFor: 'testing' stamp: 'lr 3/21/2005 13:50'!
isResumable
	^self resumable.! !

!MAError methodsFor: 'accessing' stamp: 'lr 3/21/2005 13:49'!
resumable
	^resumable! !

!MAError methodsFor: 'accessing' stamp: 'lr 3/21/2005 13:50'!
resumable: aBoolean
	resumable := aBoolean! !

!MAError methodsFor: 'accessing' stamp: 'lr 4/7/2005 22:28'!
wrapper
	^wrapper! !

!MAError methodsFor: 'accessing' stamp: 'lr 4/7/2005 22:28'!
wrapper: aWrapper
	wrapper := aWrapper! !

MAError subclass: #MAReadonlyError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

MAError subclass: #MARequiredError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

MAError subclass: #MAValidationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

Object subclass: #MABlockToRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MABlockToRelation class methodsFor: 'instance creation' stamp: 'lr 4/13/2005 21:31'!
do: aBlock
	^aBlock value: self new.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 4/13/2005 21:19'!
< anObject
	^MASelectorRelation selector: #< with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 4/13/2005 21:19'!
<= anObject
	^MASelectorRelation selector: #<= with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 4/13/2005 21:19'!
= anObject
	^MASelectorRelation selector: #= with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 4/13/2005 21:19'!
> anObject
	^MASelectorRelation selector: #> with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 4/13/2005 21:18'!
>= anObject
	^MASelectorRelation selector: #>= with: anObject.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 4/13/2005 21:22'!
beginsWith: anObject
	^MASelectorRelation selector: #beginsWith: with: anObject.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 4/13/2005 21:18'!
between: aMinimum and: aMaximum 
	^MASelectorRelation selector: #between:and: with: aMinimum with: aMaximum.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 4/13/2005 21:22'!
endsWith: anObject
	^MASelectorRelation selector: #endsWith: with: anObject.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 4/13/2005 21:21'!
includes: anObject
	^MASelectorRelation selector: #includes: with: anObject.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 4/13/2005 21:20'!
isEmpty
	^MASelectorRelation selector: #isEmpty.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 4/13/2005 21:24'!
isEven
	^MASelectorRelation selector: #even.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 4/13/2005 21:25'!
isFloat
	^MASelectorRelation selector: #isFloat.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 4/13/2005 21:24'!
isInteger
	^MASelectorRelation selector: #isInteger.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 4/13/2005 21:24'!
isNegative
	^MASelectorRelation selector: #negative.! !

!MABlockToRelation methodsFor: 'testing-objects' stamp: 'lr 4/13/2005 21:19'!
isNil
	^MASelectorRelation selector: #isNil.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 4/13/2005 21:24'!
isOdd
	^MASelectorRelation selector: #odd.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 4/13/2005 21:24'!
isPositive
	^MASelectorRelation selector: #positive.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 4/13/2005 21:23'!
isZero
	^MASelectorRelation selector: #isZero.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 4/13/2005 21:21'!
notEmpty
	^MASelectorRelation selector: #notEmpty.! !

!MABlockToRelation methodsFor: 'testing-objects' stamp: 'lr 4/13/2005 21:20'!
notNil
	^MASelectorRelation selector: #notNil.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 4/13/2005 21:19'!
~= anObject
	^MASelectorRelation selector: #~= with: anObject.! !

Object subclass: #MABuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

MABuilder class
	instanceVariableNames: 'default'!

!MABuilder class methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:55'!
default
	default isNil
		ifTrue: [ default := self new ].
	^default.! !

!MABuilder methodsFor: 'actions' stamp: 'lr 4/9/2005 12:36'!
build: anObject
	| description |
	^anObject defaultContainer in: [ :container |
		anObject class allSelectors do: [ :each |
			(self isDescriptionSelector: each) ifTrue: [ 
				description := anObject perform: each.
				description isDescription
					ifTrue: [ container := container , description ] ] ].
		container ].! !

!MABuilder methodsFor: 'testing' stamp: 'lr 4/5/2005 21:04'!
isDescriptionSelector: aSelector
	^aSelector notNil
		and: [ aSelector isUnary ]
		and: [ aSelector ~= #description ] 
		and: [ aSelector beginsWith: #description ].! !

MABuilder subclass: #MACachedBuilder
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 4/5/2005 20:09'!
build: anObject
	^self cache
		at: anObject
		ifAbsentPut: [ super build: anObject ].! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:46'!
cache
	^cache! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:46'!
cache: aDictionary
	cache := aDictionary! !

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 4/5/2005 20:42'!
flush
	self cache: IdentityDictionary new.! !

!MACachedBuilder methodsFor: 'initialization' stamp: 'lr 4/5/2005 19:56'!
initialize
	super initialize.
	self flush; register.! !

!MACachedBuilder methodsFor: 'events' stamp: 'lr 4/5/2005 21:04'!
modified: anEvent
	(self isDescriptionSelector: anEvent itemSelector) 
		ifTrue: [ self flush ].! !

!MACachedBuilder methodsFor: 'events' stamp: 'lr 4/5/2005 20:46'!
register
	SystemChangeNotifier uniqueInstance
		noMoreNotificationsFor: self;
		notify: self ofSystemChangesOfItem: #method change: #Added using: #modified:;
		notify: self ofSystemChangesOfItem: #method change: #Modified using: #modified:;
		notify: self ofSystemChangesOfItem: #method change: #Removed using: #modified:.! !

Object subclass: #MAObject
	instanceVariableNames: 'hash properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core'!

MAObject subclass: #MADescription
	instanceVariableNames: 'accessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MADescription subclass: #MAContainer
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAContainer class methodsFor: 'accessing-defaults' stamp: 'lr 4/6/2005 20:09'!
defaultAccessor
	^MAContainerAccessor new.! !

!MAContainer class methodsFor: 'accessing-defaults' stamp: 'lr 3/24/2005 00:15'!
defaultCollection
	^OrderedCollection new.! !

!MAContainer class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MAContainer class methodsFor: 'instance creation' stamp: 'lr 3/24/2005 00:07'!
with: aDescription
	^self new
		add: aDescription;
		yourself.! !

!MAContainer class methodsFor: 'instance creation' stamp: 'lr 3/24/2005 00:08'!
withAll: aCollection
	^self new
		addAll: aCollection;
		yourself.! !

!MAContainer methodsFor: 'visiting' stamp: 'lr 4/9/2005 13:05'!
acceptMagritte: aVisitor
	aVisitor visitContainer: self.! !

!MAContainer methodsFor: 'adding' stamp: 'lr 3/24/2005 00:09'!
add: aDescription
	self children add: aDescription.! !

!MAContainer methodsFor: 'adding' stamp: 'lr 3/9/2005 22:52'!
addAll: aCollection
	aCollection do: [ :each | self add: each ].! !

!MAContainer methodsFor: 'converting' stamp: 'lr 3/24/2005 12:19'!
asContainer
	^self! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:51'!
children
	^children! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 12:06'!
collect: aBlock
	^self copy 
		setChildren: (self children collect: aBlock);
		yourself.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 3/24/2005 12:08'!
copyFrom: aStartIndex to: anEndIndex
	^self copy 
		setChildren: (self children
			copyFrom: aStartIndex 
			to: anEndIndex);
		yourself.! !

!MAContainer methodsFor: 'copying' stamp: 'avi 4/14/2005 13:10'!
copyInto: aDictionary
	^ aDictionary at: self put:
		(self copy setChildren: (self children collect: [:ea | ea copyInto: aDictionary]))! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 17:31'!
detect: aBlock 
	^self children detect: aBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 10:42'!
detect: aBlock ifNone: anExceptionBlock 
	^self children detect: aBlock ifNone: anExceptionBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/10/2005 10:52'!
do: aBlock
	self children do: aBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 00:19'!
do: aBlock separatedBy: aSeparatorBlock
	self children do: aBlock separatedBy: aSeparatorBlock.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 4/4/2005 13:53'!
hasChildren
	^self notEmpty.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 4/13/2005 20:12'!
includes: aDescription
	^self children includes: aDescription.! !

!MAContainer methodsFor: 'initialization' stamp: 'lr 4/9/2005 01:28'!
initialize
	super initialize.
	self setChildren: self class defaultCollection.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 00:19'!
inject: anObject into: aBlock 
	^self children inject: anObject into: aBlock.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 4/6/2005 15:17'!
isContainer	
	^true! !

!MAContainer methodsFor: 'testing' stamp: 'lr 3/22/2005 16:32'!
isEmpty
	^self children isEmpty.! !

!MAContainer methodsFor: 'moving' stamp: 'lr 4/6/2005 20:15'!
moveDown: aDescription
	| index |
	index := self children 
		indexOf: aDescription 
		ifAbsent: [ ^self ].
	self children swap: index with: (index = self size
		ifFalse:[ index + 1 ]
		ifTrue: [ 1 ]).! !

!MAContainer methodsFor: 'moving' stamp: 'lr 4/6/2005 20:15'!
moveUp: aDescription
	| index |
	index := self children 
		indexOf: aDescription 
		ifAbsent: [ ^self ].
	self children swap: index with: (index = 1
		ifFalse:[ index - 1 ]
		ifTrue: [ self size ]).! !

!MAContainer methodsFor: 'testing' stamp: 'lr 3/22/2005 16:39'!
notEmpty
	^self children notEmpty.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 3/24/2005 12:36'!
postCopy
	super postCopy.
	self setChildren: self children copy.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 12:06'!
reject: aBlock
	^self copy 
		setChildren: (self children reject: aBlock);
		yourself.! !

!MAContainer methodsFor: 'removing' stamp: 'lr 3/24/2005 00:09'!
remove: aDescription
	self children remove: aDescription ifAbsent: [ ].! !

!MAContainer methodsFor: 'removing' stamp: 'lr 3/24/2005 10:08'!
removeAll
	children := self class defaultCollection.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 12:06'!
select: aBlock
	^self copy 
		setChildren: (self children select: aBlock);
		yourself.! !

!MAContainer methodsFor: 'initialization' stamp: 'lr 3/24/2005 00:13'!
setChildren: aCollection
	children := aCollection! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 3/24/2005 00:11'!
size
	^self children size.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 3/24/2005 15:31'!
withIndexDo: aBlock
	self children withIndexDo: aBlock.! !

MAContainer subclass: #MAPriorityContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAPriorityContainer class methodsFor: 'accessing-defaults' stamp: 'lr 4/6/2005 20:01'!
defaultCollection
	^SortedCollection new.! !

!MAPriorityContainer methodsFor: 'moving' stamp: 'lr 4/6/2005 22:15'!
moveDown: aDescription
	aDescription priority: aDescription priority - 1.
	self resort.! !

!MAPriorityContainer methodsFor: 'moving' stamp: 'lr 4/6/2005 22:15'!
moveUp: aDescription
	aDescription priority: aDescription priority + 1.
	self resort.! !

!MAPriorityContainer methodsFor: 'actions' stamp: 'lr 4/6/2005 22:16'!
resort
	self setChildren: self children copy.! !

MAContainer subclass: #MAReportContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 3/23/2005 23:47'!
defaultCaption
	^nil! !

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 3/23/2005 23:47'!
defaultEmpty
	^'The report is empty.'! !

!MAReportContainer class methodsFor: 'accessing-defaults-batch' stamp: 'lr 3/23/2005 23:51'!
defaultPageSize
	^10! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 3/23/2005 23:57'!
defaultShowBatch
	^true! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 3/23/2005 23:57'!
defaultShowFooter
	^true! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 3/23/2005 23:57'!
defaultShowHeader
	^true! !

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 3/23/2005 23:47'!
defaultSummary
	^nil! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 3/28/2005 12:09'!
descriptionCaption
	^MAStringDescription selector: #caption label: 'Caption' priority: 1000 default: self defaultCaption.! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 3/28/2005 12:09'!
descriptionEmpty
	^MAStringDescription selector: #empty label: 'Empty' priority: 1200 default: self defaultEmpty.! !

!MAReportContainer class methodsFor: 'accessing-description-batch' stamp: 'lr 3/28/2005 12:09'!
descriptionPageSize
	^MANumberDescription selector: #pageSize label: 'Page Size' priority: 2000 default: self defaultPageSize.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 3/28/2005 12:10'!
descriptionShowBatch
	^MABooleanDescription selector: #showBatch label: 'Show Batch' priority: 3200 default: self defaultShowBatch.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 3/28/2005 12:10'!
descriptionShowFooter
	^MABooleanDescription selector: #showFooter label: 'Show Footer' priority: 3100 default: self defaultShowFooter.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 3/28/2005 12:10'!
descriptionShowHeader
	^MABooleanDescription selector: #showHeader label: 'Show Header' priority: 3000 default: self defaultShowHeader.! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 3/28/2005 12:10'!
descriptionSummary
	^MAStringDescription selector: #summary label: 'Summary' priority: 1100 default: self defaultSummary.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 3/23/2005 23:42'!
caption
	^self propertyAt: #caption ifAbsent: [ self class defaultCaption ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 3/23/2005 23:42'!
caption: aString
	self propertyAt: #caption put: aString.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 3/23/2005 23:45'!
empty
	^self propertyAt: #empty ifAbsent: [ self class defaultEmpty ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 3/23/2005 23:45'!
empty: aString
	self propertyAt: #empty put: aString.! !

!MAReportContainer methodsFor: 'accessing-batch' stamp: 'lr 3/23/2005 23:51'!
pageSize
	^self propertyAt: #pageSize ifAbsent: [ self class defaultPageSize ].! !

!MAReportContainer methodsFor: 'accessing-batch' stamp: 'lr 3/23/2005 23:50'!
pageSize: aNumber
	self propertyAt: #pageSize put: aNumber.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 3/23/2005 23:54'!
showBatch
	^self propertyAt: #showBatch ifAbsent: [ self class defaultShowBatch ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 3/23/2005 23:54'!
showBatch: aBoolean
	self propertyAt: #showBatch put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 3/23/2005 23:54'!
showFooter
	^self propertyAt: #showFooter ifAbsent: [ self class defaultShowFooter ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 3/23/2005 23:53'!
showFooter: aBoolean
	self propertyAt: #showFooter put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 3/23/2005 23:53'!
showHeader
	^self propertyAt: #showHeader ifAbsent: [ self class defaultShowHeader ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 3/23/2005 23:53'!
showHeader: aBoolean
	self propertyAt: #showHeader put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 3/23/2005 23:44'!
summary
	^self propertyAt: #summary ifAbsent: [ self class defaultSummary ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 3/23/2005 23:44'!
summary: aString
	self propertyAt: #summary put: aString.! !

!MADescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:42'!
asLabel
	^super asLabel allButFirst: 2.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/6/2005 20:09'!
defaultAccessor
	^MANullAccessor new.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/23/2005 07:21'!
defaultComment
	^nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/13/2005 19:53'!
defaultCondition
	^MAConstantRelation true.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2005 18:33'!
defaultLabel
	^nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/19/2005 12:30'!
defaultPersistent
	^true! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 10:27'!
defaultPriority
	^0! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:23'!
defaultReadonly
	^false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/11/2005 20:39'!
defaultRequired
	^false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 10:28'!
defaultVisible
	^true! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:36'!
descriptionComment
	^MATextDescription selector: #comment label: 'Comment' priority: 110 default: self defaultComment.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:36'!
descriptionLabel
	^MAStringDescription selector: #label label: 'Label' priority: 100 default: self defaultLabel.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:35'!
descriptionPersistent
	^MABooleanDescription selector: #persistent label: 'Persistent' priority: 330 default: self defaultPersistent.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:35'!
descriptionPriority
	^MANumberDescription selector: #priority label: 'Priority' priority: 120 default: self defaultPriority.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:36'!
descriptionReadonly
	^MABooleanDescription selector: #readonly label: 'Readonly' priority: 300 default: self defaultReadonly.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/28/2005 12:11'!
descriptionRequired
	^MABooleanDescription selector: #required label: 'Required' priority: 320 default: self defaultRequired.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/28/2005 12:11'!
descriptionVisible
	^MABooleanDescription selector: #visible label: 'Visible' priority: 310 default: self defaultVisible.! !

!MADescription class methodsFor: 'testing' stamp: 'lr 3/28/2005 19:03'!
isAbstract
	^true! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/28/2005 19:03'!
new
	"Create a new instance of the receiving class and checks if it is concrete."

	self isAbstract
		ifTrue: [ self error: self name , ' is abstract.' ].
	^super new.! !

!MADescription methodsFor: 'operators' stamp: 'lr 3/24/2005 12:31'!
, aDescription
	"Merge the receiver and aDescription to one composed description"

	^self asContainer copy
		addAll: aDescription asContainer;
		yourself.! !

!MADescription methodsFor: 'operators' stamp: 'lr 4/6/2005 20:04'!
<= anObject
	"Answer whether the receiver should precede anObject in a priority container."
	
	^self priority <= anObject priority.! !

!MADescription methodsFor: 'visiting' stamp: 'lr 4/9/2005 13:04'!
acceptMagritte: aVisitor
	aVisitor visitDescription: self.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 4/6/2005 20:08'!
accessor
	accessor isNil
		ifTrue: [ self accessor: self class defaultAccessor ].
	^accessor.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 4/11/2005 10:49'!
accessor: anAccessor	
	accessor := anAccessor! !

!MADescription methodsFor: 'converting' stamp: 'lr 3/24/2005 00:04'!
asContainer
	self subclassResponsibility.! !

!MADescription methodsFor: 'converting' stamp: 'lr 3/27/2005 10:52'!
asLabel
	^self label ifNil: [ super asLabel ].! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/14/2005 18:12'!
beEphemeral
	self persistent: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beHidden
	self visible: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/11/2005 20:31'!
beOptional
	self required: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/14/2005 18:12'!
bePersistent
	self persistent: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beReadonly
	self readonly: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/11/2005 20:25'!
beRequired
	self required: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beVisible
	self visible: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beWriteable
	self readonly: false.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/23/2005 23:43'!
comment	
	^self propertyAt: #comment ifAbsent: [ self class defaultComment ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/27/2005 11:07'!
comment: aString
	self propertyAt: #comment put: aString.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 4/13/2005 19:56'!
condition	
	^self propertyAt: #condition ifAbsent: [ self class defaultCondition ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 4/13/2005 21:40'!
condition: aCondition
	self propertyAt: #condition put: ((aCondition isKindOf: BlockContext)
		ifTrue: [ MABlockToRelation do: aCondition ]
		ifFalse: [ aCondition ]).! !

!MADescription methodsFor: 'copying' stamp: 'avi 4/14/2005 12:56'!
copyInto: aDictionary
	^ aDictionary at: self put: self copy! !

!MADescription methodsFor: 'testing' stamp: 'lr 4/4/2005 13:53'!
hasChildren
	^false! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/23/2005 07:28'!
hasComment
	^(self propertyAt: #comment ifAbsent: [ ^false ])
		isEmptyOrNil not.! !

!MADescription methodsFor: 'testing' stamp: 'lr 4/11/2005 10:20'!
hasCondition
	^self propertyAt: #condition ifAbsent: [ ^false ].! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/27/2005 12:01'!
hasLabel
	^(self propertyAt: #label ifAbsent: [ ^false ])
		isEmptyOrNil not.! !

!MADescription methodsFor: 'testing' stamp: 'lr 4/6/2005 15:17'!
isContainer	
	^false! !

!MADescription methodsFor: 'testing' stamp: 'lr 4/9/2005 12:36'!
isDescription
	^true! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/14/2005 18:11'!
isPersistent
	^self persistent.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/10/2005 10:14'!
isReadonly
	^self readonly.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/11/2005 20:31'!
isRequired
	^self required.! !

!MADescription methodsFor: 'testing' stamp: 'lr 4/13/2005 20:11'!
isSatisfiedBy: anObject
	"Return true or false wheter anObject is a proper value of the receiver."

	^(anObject isKindOf: self kind)
		and: [ self condition isSatisfiedBy: anObject ].! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/10/2005 10:14'!
isVisible
	^self visible.! !

!MADescription methodsFor: 'private' stamp: 'lr 4/6/2005 23:46'!
key
	^[ self accessor selector ]
		on: Error
		do: [ :err | nil ].! !

!MADescription methodsFor: 'accessing-configuration' stamp: 'lr 4/11/2005 10:23'!
kind
	^Object! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/27/2005 11:07'!
label	
	^self propertyAt: #label ifAbsent: [ self class defaultLabel ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/27/2005 11:07'!
label: aString
	self propertyAt: #label put: aString.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/23/2005 23:43'!
persistent	
	^self propertyAt: #persistent ifAbsent: [ self class defaultPersistent ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/14/2005 18:11'!
persistent: aBoolean
	self propertyAt: #persistent put: aBoolean.! !

!MADescription methodsFor: 'copying' stamp: 'lr 4/8/2005 23:26'!
postCopy
	super postCopy.
	self accessor: self accessor copy.! !

!MADescription methodsFor: 'printing' stamp: 'lr 4/8/2005 17:20'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' label: '; print: self label.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/23/2005 23:43'!
priority
	^self propertyAt: #priority ifAbsent: [ self class defaultPriority ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/17/2005 15:17'!
priority: aNumber
	self propertyAt: #priority put: aNumber.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/23/2005 23:43'!
readonly	
	^self propertyAt: #readonly ifAbsent: [ self class defaultReadonly ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:11'!
readonly: aBoolean	
	self propertyAt: #readonly put: aBoolean.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/23/2005 23:43'!
required	
	^self propertyAt: #required 	ifAbsent: [ self class defaultRequired ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/11/2005 20:24'!
required: aBoolean	
	self propertyAt: #required put: aBoolean.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/23/2005 23:43'!
visible	
	^self propertyAt: #visible ifAbsent: [ self class defaultVisible ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:11'!
visible: aBoolean
	self propertyAt: #visible put: aBoolean.! !

MADescription subclass: #MAElementDescription
	instanceVariableNames: 'default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAElementDescription subclass: #MABinaryDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MABinaryDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Upload'! !

!MABinaryDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MABinaryDescription methodsFor: 'accessing' stamp: 'lr 3/30/2005 07:30'!
kind
	^ByteArray! !

!MABinaryDescription methodsFor: 'converting' stamp: 'lr 3/15/2005 21:41'!
parseString: aString
	^self parseString: aString protected: [ ByteArray withAll: aString ].! !

MAElementDescription subclass: #MABooleanDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MABooleanDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Check-Box'! !

!MABooleanDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MABooleanDescription methodsFor: 'private' stamp: 'lr 3/11/2005 21:40'!
falseStrings
	^ #( 'false' 'f' 'no' 'n' '0' 'off' )! !

!MABooleanDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:16'!
kind
	^Boolean! !

!MABooleanDescription methodsFor: 'converting' stamp: 'lr 3/14/2005 16:10'!
parseString: aString
	^self parseString: aString protected: [
		(self trueStrings includes: aString)
			ifTrue: [ ^true ].
		(self falseStrings includes: aString)
			ifTrue: [ ^false ].
		aString ].! !

!MABooleanDescription methodsFor: 'private' stamp: 'lr 3/11/2005 21:40'!
trueStrings
	^ #( 'true' 't' 'yes' 'y' '1' 'on' )! !

!MAElementDescription class methodsFor: 'instance-creation' stamp: 'lr 3/27/2005 10:19'!
accessor: anAccessor
	^self accessor: anAccessor label: self defaultLabel.! !

!MAElementDescription class methodsFor: 'instance-creation' stamp: 'lr 3/27/2005 10:19'!
accessor: anAccessor label: aString
	^self accessor: anAccessor label: aString priority: self defaultPriority.! !

!MAElementDescription class methodsFor: 'instance-creation' stamp: 'lr 4/6/2005 22:23'!
accessor: anAccessor label: aString priority: aNumber
	^self accessor: anAccessor label: aString priority: aNumber default: self defaultDefault.! !

!MAElementDescription class methodsFor: 'instance-creation' stamp: 'lr 4/11/2005 10:01'!
accessor: anAccessor label: aString priority: aNumber default: anObject
	^self new
		accessor: anAccessor;
		label: aString;
		priority: aNumber;
		default: anObject;
		yourself.! !

!MAElementDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/14/2005 11:48'!
defaultDefault
	^nil! !

!MAElementDescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:37'!
descriptionDefault
	^self isAbstract 
		ifFalse: [ self selector: #default label: 'Default' priority: 200 default: self defaultDefault ].! !

!MAElementDescription class methodsFor: 'instance-creation-block' stamp: 'lr 4/6/2005 22:28'!
read: aReadBlock write: aWriteBlock
	^self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock).! !

!MAElementDescription class methodsFor: 'instance-creation-block' stamp: 'lr 4/6/2005 22:28'!
read: aReadBlock write: aWriteBlock label: aString
	^self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock) label: aString.! !

!MAElementDescription class methodsFor: 'instance-creation-block' stamp: 'lr 4/6/2005 22:28'!
read: aReadBlock write: aWriteBlock label: aString priority: aNumber
	^self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock) label: aString priority: aNumber.! !

!MAElementDescription class methodsFor: 'instance-creation-block' stamp: 'lr 4/6/2005 22:28'!
read: aReadBlock write: aWriteBlock label: aString priority: aNumber default: anObject
	^self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock) label: aString priority: aNumber default: anObject.! !

!MAElementDescription class methodsFor: 'instance-creation-selector' stamp: 'lr 3/27/2005 10:26'!
selector: aSelector
	^self accessor: (MASelectorAccessor selector: aSelector).! !

!MAElementDescription class methodsFor: 'instance-creation-selector' stamp: 'lr 3/27/2005 10:26'!
selector: aSelector label: aString
	^self accessor: (MASelectorAccessor selector: aSelector) label: aString.! !

!MAElementDescription class methodsFor: 'instance-creation-selector' stamp: 'lr 3/27/2005 10:27'!
selector: aSelector label: aString priority: aNumber
	^self accessor: (MASelectorAccessor selector: aSelector) label: aString priority: aNumber.! !

!MAElementDescription class methodsFor: 'instance-creation-selector' stamp: 'lr 3/27/2005 10:27'!
selector: aSelector label: aString priority: aNumber default: anObject
	^self accessor: (MASelectorAccessor selector: aSelector) label: aString priority: aNumber default: anObject.! !

!MAElementDescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 4/6/2005 22:25'!
selectors: anArray
	^self accessor: (MACascadeAccessor selectors: anArray).! !

!MAElementDescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 4/6/2005 22:26'!
selectors: anArray label: aString
	^self accessor: (MACascadeAccessor selectors: anArray) label: aString.! !

!MAElementDescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 4/6/2005 22:26'!
selectors: anArray label: aString priority: aNumber
	^self accessor: (MACascadeAccessor selectors: anArray) label: aString priority: aNumber.! !

!MAElementDescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 4/6/2005 22:26'!
selectors: anArray label: aString priority: aNumber default: anObject
	^self accessor: (MACascadeAccessor selectors: anArray) label: aString priority: aNumber default: anObject.! !

!MAElementDescription methodsFor: 'visiting' stamp: 'lr 4/9/2005 13:05'!
acceptMagritte: aVisitor
	aVisitor visitElement: self.! !

!MAElementDescription methodsFor: 'converting' stamp: 'lr 3/24/2005 12:19'!
asContainer
	^MAContainer with: self.! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 3/29/2005 20:00'!
collectionToString: aCollection
	^String streamContents: [ :stream |
		aCollection
			do: [ :each | stream nextPutAll: each asString ]
			separatedBy: [ stream cr ] ].! !

!MAElementDescription methodsFor: 'accessing' stamp: 'lr 3/27/2005 10:17'!
default
	^default! !

!MAElementDescription methodsFor: 'accessing' stamp: 'lr 3/27/2005 10:17'!
default: anObject
	default := anObject! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 3/14/2005 16:15'!
parseString: aString
	^self parseString: aString protected: [ aString ].! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 4/3/2005 12:26'!
parseString: aString protected: aBlock
	^aString isEmptyOrNil ifFalse: [ 
		aBlock
			on: Error
			do: [ :err | err return: aString ] ].! !

!MAElementDescription methodsFor: 'copying' stamp: 'lr 3/28/2005 11:29'!
postCopy
	super postCopy.
	self accessor: self accessor copy.
	self default: self default copy.! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 3/29/2005 20:01'!
stringToCollection: aString default: aCollection
	^aString isEmptyOrNil
		ifTrue: [ aCollection ]
		ifFalse: [
			((aString findTokens: Character cr)
				collect: [ :each | each withBlanksCondensed ])
					select: [ :each | each notEmpty ] ].! !

!MAElementDescription methodsFor: 'operators' stamp: 'lr 3/21/2005 19:15'!
toString: anObject
	^anObject isNil
		ifTrue: [ String new ]
		ifFalse: [ anObject asLabel ].! !

MAElementDescription subclass: #MAMagnitudeDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAMagnitudeDescription subclass: #MADateDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MADateDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Date Field'! !

!MADateDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MADateDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:16'!
kind
	^Date! !

MAMagnitudeDescription subclass: #MADurationDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MADurationDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Duration Field'! !

!MADurationDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MADurationDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:17'!
kind
	^Duration! !

!MAMagnitudeDescription methodsFor: 'converting' stamp: 'lr 3/23/2005 14:19'!
parseString: aString
	^self parseString: aString protected: [ self kind fromString: aString ].! !

MAMagnitudeDescription subclass: #MANumberDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MANumberDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Number Field'! !

!MANumberDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MANumberDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:16'!
kind
	^Number! !

!MANumberDescription methodsFor: 'converting' stamp: 'lr 3/14/2005 16:06'!
parseString: aString
	^self parseString: aString protected: [ aString asNumber ].! !

MAMagnitudeDescription subclass: #MATimeDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATimeDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Time Field'! !

!MATimeDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MATimeDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:16'!
kind
	^Time! !

MAMagnitudeDescription subclass: #MATimeStampDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATimeStampDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:35'!
asLabel
	^'Timestamp Field'! !

!MATimeStampDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MATimeStampDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:17'!
kind
	^TimeStamp! !

MAElementDescription subclass: #MAOptionsDescription
	instanceVariableNames: 'options nilLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAOptionsDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:35'!
asLabel
	^'Option-Box'! !

!MAOptionsDescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/12/2005 14:21'!
defaultNilLabel
	^String new.! !

!MAOptionsDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 18:38'!
defaultOptions
	^OrderedCollection new.! !

!MAOptionsDescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/12/2005 12:38'!
defaultSorted
	^false! !

!MAOptionsDescription class methodsFor: 'accessing-description' stamp: 'lr 3/14/2005 12:16'!
descriptionDefault
	^nil! !

!MAOptionsDescription class methodsFor: 'accessing-description' stamp: 'lr 4/12/2005 14:21'!
descriptionNilLabel
	^MAStringDescription selector: #nilLabel label: 'Nil Label' priority: 150.! !

!MAOptionsDescription class methodsFor: 'accessing-description' stamp: 'lr 3/29/2005 20:19'!
descriptionOptions
	^MATextDescription selector: #optionsTextual label: 'Options' priority: 160.! !

!MAOptionsDescription class methodsFor: 'accessing-description' stamp: 'lr 4/12/2005 12:38'!
descriptionSorted
	^MABooleanDescription selector: #sorted label: 'Sorted' priority: 170.! !

!MAOptionsDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MAOptionsDescription methodsFor: 'accessing-conveniance' stamp: 'lr 4/12/2005 14:15'!
allOptions
	^Array streamContents: [ :stream |
		self isRequired 
			ifFalse: [ stream nextPut: nil ].
		self isSorted
			ifFalse: [ stream nextPutAll: self options ]
			ifTrue: [ 
				stream nextPutAll: (self options asSortedCollection: [ :a :b | 
					a asLabel < b asLabel ]) ] ].! !

!MAOptionsDescription methodsFor: 'actions' stamp: 'lr 4/12/2005 14:03'!
beSorted
	self sorted: true.! !

!MAOptionsDescription methodsFor: 'actions' stamp: 'lr 4/12/2005 14:03'!
beUnsorted
	self sorted: false.! !

!MAOptionsDescription methodsFor: 'testing' stamp: 'lr 4/13/2005 20:13'!
isSatisfiedBy: anObject
	^(super isSatisfiedBy: anObject)
		and: [ self options includes: anObject ].! !

!MAOptionsDescription methodsFor: 'testing' stamp: 'lr 4/12/2005 14:22'!
isSorted
	^self sorted.! !

!MAOptionsDescription methodsFor: 'accessing-properties' stamp: 'lr 3/23/2005 14:17'!
kind
	^Object! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 4/12/2005 14:19'!
nilLabel
	nilLabel isNil
		ifTrue: [ self nilLabel: self class defaultNilLabel ].
	^nilLabel.! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 4/12/2005 14:20'!
nilLabel: aString
	nilLabel := aString! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/14/2005 19:22'!
options
	options isNil
		ifTrue: [ self options: self class defaultOptions ].
	^options.! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/11/2005 22:37'!
options: aCollection
	options := aCollection! !

!MAOptionsDescription methodsFor: 'private' stamp: 'lr 3/15/2005 18:38'!
optionsTextual
	^self collectionToString: self options.! !

!MAOptionsDescription methodsFor: 'private' stamp: 'lr 3/15/2005 18:38'!
optionsTextual: aString
	self options: (self stringToCollection: aString default: self class defaultOptions).! !

!MAOptionsDescription methodsFor: 'copying' stamp: 'lr 3/11/2005 22:36'!
postCopy
	super postCopy.
	self options: self options copy.! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 4/12/2005 12:38'!
sorted
	^self propertyAt: #sorted ifAbsentPut: [ self class defaultSorted ].! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 4/12/2005 12:37'!
sorted: aBoolean
	self propertyAt: #sorted put: aBoolean.! !

MAElementDescription subclass: #MAStringDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAStringDescription subclass: #MAPasswordDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAPasswordDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:36'!
asLabel
	^'Password Field'! !

!MAPasswordDescription methodsFor: 'testing' stamp: 'lr 4/6/2005 23:24'!
isObfuscated: anObject
	^anObject notNil
		and: [ anObject isString ] 
		and: [ anObject allSatisfy: [ :each | each = $* ] ].! !

!MAPasswordDescription methodsFor: 'operators' stamp: 'lr 4/6/2005 23:26'!
obfuscated: anObject
	^String new: (self toString: anObject) size withAll: $*.! !

!MAStringDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Text Field'! !

!MAStringDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MAStringDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:17'!
kind
	^String! !

MAStringDescription subclass: #MASymbolDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MASymbolDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:36'!
asLabel
	^'Symbol Field'! !

!MASymbolDescription methodsFor: 'accessing' stamp: 'lr 3/23/2005 14:17'!
kind
	^Symbol! !

!MASymbolDescription methodsFor: 'converting' stamp: 'lr 3/14/2005 16:06'!
parseString: aString
	^self parseString: aString protected: [ aString asSymbol ].! !

MAStringDescription subclass: #MATextDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATextDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:36'!
asLabel
	^'Memo Field'! !

MAElementDescription subclass: #MATableDescription
	instanceVariableNames: 'rowLabels columnLabels cellDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATableDescription class methodsFor: 'converting' stamp: 'lr 4/4/2005 18:34'!
asLabel
	^'Table'! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/16/2005 20:33'!
defaultCellDescription
	^self defaultCellDescriptionClasses first new.! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 4/14/2005 12:15'!
defaultCellDescriptionClasses
	^Array 
		with: MAStringDescription
		with: MANumberDescription
		with: MABooleanDescription.! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 22:37'!
defaultColumnLabels
	^OrderedCollection new! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 22:37'!
defaultRowLables
	^OrderedCollection new! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/29/2005 20:23'!
descriptionCellDescription
	^(MAOptionsDescription selector: #cellDescription label: 'Type' priority: 270 default: self defaultCellDescription)
		options: (self defaultCellDescriptionClasses collect: [ :each |
			each new
				label: each description label; 
				yourself ]);
		beRequired;
		yourself.! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:37'!
descriptionColumnLabels
	^MATextDescription selector: #columnLabelsTextual label: 'Column Labels' priority: 250.! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/15/2005 09:06'!
descriptionDefault
	^nil! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/15/2005 09:20'!
descriptionRequired
	^nil! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/27/2005 10:37'!
descriptionRowLabels
	^MATextDescription selector: #rowLabelsTextual label: 'Row Labels' priority: 260.! !

!MATableDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 3/29/2005 20:59'!
cellCount
	^self columnCount * self rowCount.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/16/2005 20:26'!
cellDescription
	cellDescription isNil
		ifTrue: [ self cellDescription: self class defaultCellDescription ].
	^cellDescription.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/16/2005 20:27'!
cellDescription: aDescription
	cellDescription := aDescription.! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:38'!
columnCount
	^self columnLabels size.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 22:35'!
columnLabels
	columnLabels isNil 
		ifTrue: [ self columnLabels: self class defaultColumnLabels ].
	^columnLabels.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 22:35'!
columnLabels: aCollection
	columnLabels := aCollection! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 22:36'!
columnLabelsTextual
	^self collectionToString: self columnLabels.! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 22:36'!
columnLabelsTextual: aString
	^self columnLabels: (self stringToCollection: aString default: self class defaultColumnLabels).! !

!MATableDescription methodsFor: 'accessing-indexes' stamp: 'lr 3/29/2005 21:05'!
columnOfIndex: anInteger
	| index |
	index := anInteger \\ self columnCount.
	^index isZero
		ifTrue: [ self columnCount ]
		ifFalse: [ index ].! !

!MATableDescription methodsFor: 'accessing-indexes' stamp: 'lr 4/9/2005 12:37'!
indexAt: aRowIndex at: aColIndex 
	^((aRowIndex - 1) * self columnCount) + aColIndex.! !

!MATableDescription methodsFor: 'testing' stamp: 'lr 4/13/2005 20:13'!
isSatisfiedBy: anObject
	^(super isSatisfiedBy: anObject)
		and: [ self cellCount = anObject size ].! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 3/23/2005 14:17'!
kind
	^SequenceableCollection! !

!MATableDescription methodsFor: 'copying' stamp: 'lr 3/16/2005 20:27'!
postCopy
	super postCopy.
	self rowLabels: self rowLabels copy.
	self columnLabels: self columnLabels copy.
	self cellDescription: self cellDescription copy.! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:11'!
rowCount
	^self rowLabels size.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 09:06'!
rowLabels
	rowLabels isNil 
		ifTrue: [ self rowLabels: self class defaultRowLables ].
	^rowLabels.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 08:50'!
rowLabels: aCollection
	rowLabels := aCollection! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 08:56'!
rowLabelsTextual
	^self collectionToString: self rowLabels.! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 08:57'!
rowLabelsTextual: aString
	^self rowLabels: (self stringToCollection: aString default: self class defaultRowLables).! !

!MATableDescription methodsFor: 'accessing-indexes' stamp: 'lr 3/29/2005 21:05'!
rowOfIndex: anInteger
	^anInteger - 1 // self columnCount + 1.! !

MAObject subclass: #MAModelAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

MAModelAccessor subclass: #MABlockAccessor
	instanceVariableNames: 'readBlock writeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MABlockAccessor class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:36'!
isAbstract
	^false! !

!MABlockAccessor class methodsFor: 'instance creation' stamp: 'lr 3/30/2005 14:26'!
read: aReadBlock write: aWriteBlock
	^self new
		readBlock: aReadBlock;
		writeBlock: aWriteBlock;
		yourself.! !

!MABlockAccessor methodsFor: 'testing' stamp: 'lr 4/11/2005 11:11'!
canRead
	^self readBlock notNil.! !

!MABlockAccessor methodsFor: 'testing' stamp: 'lr 4/11/2005 11:11'!
canWrite
	^self writeBlock notNil.! !

!MABlockAccessor methodsFor: 'printing' stamp: 'lr 4/11/2005 10:57'!
printBlock: aBlock on: aStream
	aStream nextPutAll: aBlock decompile asString allButFirst allButLast.! !

!MABlockAccessor methodsFor: 'printing' stamp: 'lr 4/11/2005 11:03'!
printRead: aModel on: aStream
	self printBlock: self readBlock on: aStream.
	aStream nextPutAll: ' value: '; nextPutAll: aModel asString.! !

!MABlockAccessor methodsFor: 'printing' stamp: 'lr 4/11/2005 11:09'!
printWrite: anObject to: aModel on: aStream
	self printBlock: self writeBlock on: aStream.
	aStream nextPutAll: ' value: '; nextPutAll: aModel asString.
	aStream nextPutAll: ' value: '; nextPutAll: anObject asString.! !

!MABlockAccessor methodsFor: 'model' stamp: 'lr 3/27/2005 10:01'!
read: aModel
	^self readBlock value: aModel.! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 10:01'!
readBlock
	^readBlock! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 10:01'!
readBlock: aBlock
	readBlock := aBlock! !

!MABlockAccessor methodsFor: 'model' stamp: 'lr 3/28/2005 23:04'!
write: anObject to: aModel
	self writeBlock value: aModel value: anObject.! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 10:02'!
writeBlock
	^writeBlock! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 10:02'!
writeBlock: aBlock
	writeBlock := aBlock! !

MAModelAccessor subclass: #MACascadeAccessor
	instanceVariableNames: 'accessor next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MACascadeAccessor class methodsFor: 'instance creation' stamp: 'lr 3/27/2005 09:51'!
cascade: anArray
	^anArray allButLast reverse
		inject: anArray last
		into: [ :next :accessor | 
			self new
				next: next; 
				accessor: accessor;
				yourself ].! !

!MACascadeAccessor class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:36'!
isAbstract
	^false! !

!MACascadeAccessor class methodsFor: 'instance creation' stamp: 'lr 3/27/2005 09:50'!
selectors: anArray
	^self cascade: (anArray collect: [ :each | 
		MASelectorAccessor selector: each ]).! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 09:38'!
accessor
	^accessor! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 09:42'!
accessor: anAccessor
	accessor := anAccessor! !

!MACascadeAccessor methodsFor: 'testing' stamp: 'lr 4/11/2005 11:26'!
canRead
	^self next canRead.! !

!MACascadeAccessor methodsFor: 'testing' stamp: 'lr 4/11/2005 11:13'!
canWrite
	^self next canWrite.! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 09:38'!
next
	^next! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 3/27/2005 09:42'!
next: anAccessor
	next := anAccessor! !

!MACascadeAccessor methodsFor: 'copying' stamp: 'lr 3/30/2005 22:10'!
postCopy
	super postCopy.
	self accessor: self accessor copy.
	self next: self next copy.! !

!MACascadeAccessor methodsFor: 'printing' stamp: 'lr 4/11/2005 11:06'!
printRead: aModel on: aStream
	self next 
		printRead: (String streamContents: [ :stream |
			self accessor 
				printRead: aModel 
				on: stream ])
		on: aStream.! !

!MACascadeAccessor methodsFor: 'printing' stamp: 'lr 4/11/2005 11:08'!
printWrite: anObject to: aModel on: aStream
	self next
		printWrite: anObject
		to: (String streamContents: [ :stream |
			self accessor
				printRead: aModel
				on: stream ])
		on: aStream.! !

!MACascadeAccessor methodsFor: 'model' stamp: 'lr 3/30/2005 10:54'!
read: aModel
	^self next read: (self accessor read: aModel).! !

!MACascadeAccessor methodsFor: 'model' stamp: 'lr 3/28/2005 23:04'!
write: anObject to: aModel
	self next write: anObject to: (self accessor read: aModel).! !

MAModelAccessor subclass: #MAContainerAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MAContainerAccessor class methodsFor: 'testing' stamp: 'lr 4/5/2005 13:10'!
isAbstract
	^false! !

!MAContainerAccessor methodsFor: 'testing' stamp: 'lr 4/11/2005 11:31'!
canRead
	^true! !

!MAContainerAccessor methodsFor: 'testing' stamp: 'lr 4/11/2005 11:31'!
canWrite
	^false! !

!MAContainerAccessor methodsFor: 'printing' stamp: 'lr 4/11/2005 11:32'!
printRead: aModel on: aStream
	aStream nextPutAll: aModel asString.! !

!MAContainerAccessor methodsFor: 'model' stamp: 'lr 4/5/2005 13:15'!
read: aModel
	^aModel.! !

!MAContainerAccessor methodsFor: 'model' stamp: 'lr 4/5/2005 13:15'!
write: anObject to: aModel
	self error: 'Not supposed to write to ' , aModel asString , '.'.! !

!MAModelAccessor methodsFor: 'testing' stamp: 'lr 4/11/2005 11:10'!
canRead
	^true! !

!MAModelAccessor methodsFor: 'testing' stamp: 'lr 4/11/2005 11:10'!
canWrite
	^true! !

!MAModelAccessor methodsFor: 'printing' stamp: 'lr 4/11/2005 11:11'!
printOn: aStream
	super printOn: aStream.
	self canRead ifTrue: [
		aStream nextPutAll: ' read: {'.
		self printRead: 'aModel' on: aStream.
		aStream nextPutAll: '}' ].
	self canWrite ifTrue: [
		aStream nextPutAll: ' write: {'.
		self printWrite: 'anObject' to: 'aModel' on: aStream.
		aStream nextPutAll: '}' ].! !

!MAModelAccessor methodsFor: 'printing' stamp: 'lr 4/11/2005 11:31'!
printRead: aModel on: aStream! !

!MAModelAccessor methodsFor: 'printing' stamp: 'lr 4/11/2005 10:56'!
printWrite: anObject to: aModel on: aStream! !

!MAModelAccessor methodsFor: 'model' stamp: 'lr 3/27/2005 09:55'!
read: aModel
	"Read from aModel using the description of the receiver."
	
	self subclassResponsibility.! !

!MAModelAccessor methodsFor: 'model' stamp: 'lr 3/27/2005 09:55'!
write: anObject to: aModel
	"Write to aModel using the description of the receiver and anObject as value."
	
	self subclassResponsibility.! !

MAModelAccessor subclass: #MANullAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MANullAccessor class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:36'!
isAbstract
	^false! !

!MANullAccessor methodsFor: 'testing' stamp: 'lr 4/11/2005 11:30'!
canRead
	^false! !

!MANullAccessor methodsFor: 'testing' stamp: 'lr 4/11/2005 11:30'!
canWrite
	^false! !

!MANullAccessor methodsFor: 'model' stamp: 'lr 4/5/2005 13:09'!
read: aModel
	self error: 'Not supposed to read from ' , aModel asString , '.'.! !

!MANullAccessor methodsFor: 'model' stamp: 'lr 4/5/2005 13:09'!
write: anObject to: aModel
	self error: 'Not supposed to write to ' , aModel asString , '.'.! !

MAModelAccessor subclass: #MASelectorAccessor
	instanceVariableNames: 'readSelector writeSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MASelectorAccessor class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:36'!
isAbstract
	^false! !

!MASelectorAccessor class methodsFor: 'instance creation' stamp: 'lr 3/30/2005 14:39'!
read: aReadSelector write: aWriteSelector
	^self new
		readSelector: aReadSelector;
		writeSelector: aWriteSelector;
		yourself.! !

!MASelectorAccessor class methodsFor: 'instance creation' stamp: 'lr 3/30/2005 14:40'!
selector: aSelector
	^self new
		selector: aSelector;
		yourself.! !

!MASelectorAccessor methodsFor: 'testing' stamp: 'lr 4/11/2005 11:13'!
canRead
	^self readSelector notNil.! !

!MASelectorAccessor methodsFor: 'testing' stamp: 'lr 4/11/2005 11:13'!
canWrite
	^self writeSelector notNil.! !

!MASelectorAccessor methodsFor: 'printing' stamp: 'lr 4/11/2005 11:02'!
printRead: aModel on: aStream
	aStream nextPutAll: aModel asString; space.
	aStream nextPutAll: self readSelector.! !

!MASelectorAccessor methodsFor: 'printing' stamp: 'lr 4/11/2005 11:02'!
printWrite: anObject to: aModel on: aStream
	aStream nextPutAll: aModel asString; space.
	aStream nextPutAll: self writeSelector; space.
	aStream nextPutAll: anObject asString.! !

!MASelectorAccessor methodsFor: 'model' stamp: 'lr 3/28/2005 23:03'!
read: aModel
	^aModel perform: self readSelector.! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 3/30/2005 14:35'!
readSelector
	^readSelector! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 3/30/2005 14:35'!
readSelector: aSelector
	readSelector := aSelector.! !

!MASelectorAccessor methodsFor: 'accessing-dynamic' stamp: 'lr 3/30/2005 14:40'!
selector
	^self readSelector.! !

!MASelectorAccessor methodsFor: 'accessing-dynamic' stamp: 'lr 3/30/2005 14:39'!
selector: aSelector
	self readSelector: aSelector asSymbol.
	self writeSelector: (aSelector copyWith: $:) asSymbol.! !

!MASelectorAccessor methodsFor: 'model' stamp: 'lr 3/28/2005 23:04'!
write: anObject to: aModel
	aModel perform: self writeSelector with: anObject.! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 3/30/2005 14:35'!
writeSelector
	^writeSelector! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 3/30/2005 14:35'!
writeSelector: aSelector
	writeSelector := aSelector.! !

MAObject subclass: #MAModelWrapper
	instanceVariableNames: 'model owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

MAModelWrapper subclass: #MACachedWrapper
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MACachedWrapper class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:37'!
isAbstract
	^false! !

!MACachedWrapper methodsFor: 'private' stamp: 'lr 4/7/2005 22:40'!
commit: anObject
	super commit: anObject.
	self push: anObject.! !

!MACachedWrapper methodsFor: 'testing' stamp: 'lr 4/7/2005 23:10'!
hasChanged
	^self pull ~= self value.! !

!MACachedWrapper methodsFor: 'private' stamp: 'lr 4/9/2005 00:35'!
reset: anObject
	super reset: anObject.
	self value: (self pull ifNil: [ self owner default ]).! !

!MACachedWrapper methodsFor: 'initialization' stamp: 'lr 3/31/2005 09:53'!
setModel: aModel
	super setModel: aModel.
	self reset.
	
! !

!MACachedWrapper methodsFor: 'accessing' stamp: 'lr 3/30/2005 15:21'!
value
	^value! !

!MACachedWrapper methodsFor: 'accessing' stamp: 'lr 3/30/2005 15:23'!
value: anObject
	value := anObject! !

MACachedWrapper subclass: #MACheckedWrapper
	instanceVariableNames: 'original'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MACheckedWrapper methodsFor: 'private' stamp: 'lr 4/7/2005 22:49'!
commit: anObject
	super commit: anObject.
	self original: self value.! !

!MACheckedWrapper methodsFor: 'testing' stamp: 'lr 4/8/2005 11:37'!
hasConflict
	^self hasChanged
		and: [ self pull ~= self original ].! !

!MACheckedWrapper methodsFor: 'accessing' stamp: 'lr 4/7/2005 18:38'!
original
	^original! !

!MACheckedWrapper methodsFor: 'accessing' stamp: 'lr 4/7/2005 18:38'!
original: anObject
	original := anObject! !

!MACheckedWrapper methodsFor: 'printing' stamp: 'lr 4/7/2005 23:00'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' original: '; print: self original.! !

!MACheckedWrapper methodsFor: 'private' stamp: 'lr 4/13/2005 21:49'!
reset: anObject
	super reset: anObject.
	self original: self pull.! !

!MACheckedWrapper methodsFor: 'private' stamp: 'lr 4/9/2005 12:39'!
validate: anObject
	super validate: anObject.
	self hasConflict ifTrue: [ 
		self 
			reset: anObject; 
			errorConcurrent ].! !

!MAModelWrapper class methodsFor: 'instance creation' stamp: 'lr 4/11/2005 10:50'!
on: aDescription model: aModel
	^self new
		setOwner: aDescription;
		setModel: aModel;
		yourself.! !

!MAModelWrapper methodsFor: 'accessing' stamp: 'lr 4/9/2005 00:34'!
accessor
	^self owner accessor.! !

!MAModelWrapper methodsFor: 'actions' stamp: 'lr 4/13/2005 19:42'!
commit
	"Commit the value into the model."

	self owner isReadonly
		ifTrue: [ ^self ].
	self notifyCommitBefore.
	self commit: self value.
	self notifyCommitAfter.! !

!MAModelWrapper methodsFor: 'private' stamp: 'lr 4/7/2005 22:01'!
commit: anObject
	"Primitive to commit anObject to the model. Do not call directly, use #commit instead."! !

!MAModelWrapper methodsFor: 'errors' stamp: 'lr 4/10/2005 22:08'!
errorConcurrent
	MAConcurrentError wrapper: self message: 'Concurrent modification in ' , self owner asLabel.! !

!MAModelWrapper methodsFor: 'errors' stamp: 'lr 4/10/2005 22:08'!
errorReadonly
	MAReadonlyError wrapper: self message: self owner asLabel , ' is readonly.'.! !

!MAModelWrapper methodsFor: 'errors' stamp: 'lr 4/10/2005 22:08'!
errorRequired
	MARequiredError wrapper: self message: self owner asLabel , ' is required.'.! !

!MAModelWrapper methodsFor: 'errors' stamp: 'lr 4/10/2005 22:08'!
errorValidation
	MAValidationError wrapper: self message: self owner asLabel , ' is invalid.'.! !

!MAModelWrapper methodsFor: 'accessing' stamp: 'lr 3/30/2005 15:16'!
model
	^model! !

!MAModelWrapper methodsFor: 'notification' stamp: 'lr 4/8/2005 08:31'!
notifyCommitAfter
	MACommitNotification notifyAfter: self.! !

!MAModelWrapper methodsFor: 'notification' stamp: 'lr 4/8/2005 08:32'!
notifyCommitBefore
	MACommitNotification notifyBefore: self.! !

!MAModelWrapper methodsFor: 'notification' stamp: 'lr 4/8/2005 08:32'!
notifyResetAfter
	MAResetNotification notifyAfter: self.! !

!MAModelWrapper methodsFor: 'notification' stamp: 'lr 4/8/2005 08:32'!
notifyResetBefore
	MAResetNotification notifyBefore: self.! !

!MAModelWrapper methodsFor: 'notification' stamp: 'lr 4/8/2005 08:33'!
notifyValidateAfter
	MAValidateNotification notifyAfter: self.! !

!MAModelWrapper methodsFor: 'notification' stamp: 'lr 4/8/2005 08:33'!
notifyValidateBefore
	MAValidateNotification notifyBefore: self.! !

!MAModelWrapper methodsFor: 'accessing' stamp: 'lr 4/11/2005 10:35'!
owner
	^owner! !

!MAModelWrapper methodsFor: 'copying' stamp: 'lr 4/11/2005 10:36'!
postCopy
	super postCopy.
	self setOwner: nil.! !

!MAModelWrapper methodsFor: 'printing' stamp: 'lr 4/7/2005 22:59'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' value: '; print: self value.! !

!MAModelWrapper methodsFor: 'private-model' stamp: 'lr 4/9/2005 00:35'!
pull
	"Primitive to read from the model. Do not call directly, use #value instead."

	^self model readUsing: self owner.! !

!MAModelWrapper methodsFor: 'private-model' stamp: 'lr 4/9/2005 00:35'!
push: anObject
	"Primitive to write to the model. Do not call directly, use #value: instead."

	self model write: anObject using: self owner.! !

!MAModelWrapper methodsFor: 'actions' stamp: 'lr 4/8/2005 08:29'!
reset
	"Resets the value to the one of the model."
	
	self notifyResetBefore.
	self reset: self value.
	self notifyResetAfter.! !

!MAModelWrapper methodsFor: 'private' stamp: 'lr 4/7/2005 22:02'!
reset: anObject
	"Primitive to reset anObject. Do not call directly, use #reset instead."! !

!MAModelWrapper methodsFor: 'initialization' stamp: 'lr 4/11/2005 10:34'!
setModel: aModel
	model := aModel! !

!MAModelWrapper methodsFor: 'initialization' stamp: 'lr 4/11/2005 10:34'!
setOwner: aDescription
	owner := aDescription! !

!MAModelWrapper methodsFor: 'actions' stamp: 'lr 4/9/2005 16:15'!
validate
	"Check if the value is valid within the model. In case of problems an exception is raised."

	self owner isReadonly 
		ifTrue: [ ^self ].
	self notifyValidateBefore.
	self validate: self value.
	self notifyValidateAfter.! !

!MAModelWrapper methodsFor: 'private' stamp: 'lr 4/13/2005 20:17'!
validate: anObject
	"Primitive to validate anObject. Do not call directly, use #validate instead."
	
	(self owner isRequired and: [ anObject isNil ])
		ifTrue: [ self errorRequired ].
	(anObject isNil or: [ self owner isSatisfiedBy: anObject ])
		ifFalse: [ self errorValidation ].! !

!MAModelWrapper methodsFor: 'accessing-dynamic' stamp: 'lr 4/9/2005 12:33'!
value
	self subclassResponsibility.! !

!MAModelWrapper methodsFor: 'accessing-dynamic' stamp: 'lr 4/9/2005 12:33'!
value: anObject
	self subclassResponsibility.! !

MAModelWrapper subclass: #MAStraitWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MAStraitWrapper class methodsFor: 'testing' stamp: 'lr 3/30/2005 16:37'!
isAbstract
	^false! !

!MAStraitWrapper methodsFor: 'accessing' stamp: 'lr 4/9/2005 00:36'!
value
	^self pull ifNil: [ self owner default ].! !

!MAStraitWrapper methodsFor: 'accessing' stamp: 'lr 4/7/2005 21:51'!
value: anObject
	self push: anObject.! !

!MAObject class methodsFor: 'testing' stamp: 'lr 4/8/2005 17:16'!
isAbstract
	^true! !

!MAObject class methodsFor: 'instance creation' stamp: 'lr 4/8/2005 17:17'!
new
	"Create a new instance of the receiving class and checks if it is concrete."

	self isAbstract
		ifTrue: [ self error: self name , ' is abstract.' ].
	^super new.! !

!MAObject methodsFor: 'comparing' stamp: 'lr 4/11/2005 10:13'!
= anObject
	"Compare the receiver with the argument and answer with true if the receiver is equal to the argument. Note that this test doesn't necessarily give back the right results, but presumably in most cases it does."
	
	^super = anObject 
		or: [ self isSameAs: anObject ].! !

!MAObject methodsFor: 'visiting' stamp: 'lr 4/9/2005 13:04'!
acceptMagritte: aVisitor! !

!MAObject methodsFor: 'testing' stamp: 'lr 4/11/2005 10:16'!
hasProperties
	^properties notNil and: [ properties notEmpty ].! !

!MAObject methodsFor: 'comparing' stamp: 'lr 4/8/2005 17:14'!
hash
	^hash! !

!MAObject methodsFor: 'initialization' stamp: 'lr 4/13/2005 07:43'!
initialize
	super initialize.
	self initializeHash.! !

!MAObject methodsFor: 'initialization' stamp: 'lr 4/13/2005 07:43'!
initializeHash
	"Create a new hash number to identify the receiver. This method is as a replacement to set a user defined identity hash of object."

	self setHash: SmallInteger maxVal atRandom.! !

!MAObject methodsFor: 'testing' stamp: 'lr 4/11/2005 10:17'!
inlcudesProperty: aKey
	^self hasProperties
		and: [ self properties includesKey: aKey ].! !

!MAObject methodsFor: 'private' stamp: 'avi 4/14/2005 17:15'!
isSameAs: anObject
	"Return true if the receiver and anObject are of the same type and share the same hash. In this case the two objects are presumably the same."
	
	^self species = anObject species
		and: [ self hash = anObject hash ].! !

!MAObject methodsFor: 'copying' stamp: 'lr 4/13/2005 07:47'!
postCopy
	super postCopy. 
	self initializeHash.
	properties := properties copy.! !

!MAObject methodsFor: 'printing' stamp: 'lr 4/8/2005 17:17'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $[; print: self hash; nextPut: $].! !

!MAObject methodsFor: 'accessing' stamp: 'lr 4/11/2005 10:06'!
properties
	properties isNil
		ifTrue: [ properties := Dictionary new ].
	^properties.! !

!MAObject methodsFor: 'accessing' stamp: 'lr 4/8/2005 23:25'!
propertyAt: aKey
	^self properties at: aKey.! !

!MAObject methodsFor: 'accessing' stamp: 'lr 4/8/2005 23:25'!
propertyAt: aKey ifAbsent: aBlock
	^self properties at: aKey ifAbsent: aBlock.! !

!MAObject methodsFor: 'accessing' stamp: 'lr 4/8/2005 23:25'!
propertyAt: aKey ifAbsentPut: aBlock
	^self properties at: aKey ifAbsentPut: aBlock.! !

!MAObject methodsFor: 'accessing' stamp: 'lr 4/8/2005 23:25'!
propertyAt: aKey put: aValue
	^self properties at: aKey put: aValue.! !

!MAObject methodsFor: 'initialization' stamp: 'lr 4/13/2005 07:43'!
setHash: anInteger
	hash := anInteger! !

MAObject subclass: #MARelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MARelation commentStamp: '<historical>' prior: 0!
I represent an immutable relation. Users usually want to check if the relation I am representing is satisfied by sending the message #isSatisfiedBy:!

MARelation subclass: #MABasicRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

MABasicRelation subclass: #MAConstantRelation
	instanceVariableNames: 'value'
	classVariableNames: 'FalseRelation TrueRelation'
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MAConstantRelation class methodsFor: 'accessing' stamp: 'lr 4/13/2005 19:53'!
false
	^FalseRelation! !

!MAConstantRelation class methodsFor: 'class initialization' stamp: 'lr 4/13/2005 19:53'!
initialize
	TrueRelation := self new
		setHash: 252319986;
		setValue: true;
		yourself.
	FalseRelation := self new
		setHash: 535543701;
		setValue: false;
		yourself.! !

!MAConstantRelation class methodsFor: 'testing' stamp: 'lr 4/13/2005 07:39'!
isAbstract
	^false! !

!MAConstantRelation class methodsFor: 'accessing' stamp: 'lr 4/13/2005 19:53'!
true
	^TrueRelation! !

!MAConstantRelation methodsFor: 'testing' stamp: 'lr 4/13/2005 07:38'!
isSatisfiedBy: anObject
	^self value.! !

!MAConstantRelation methodsFor: 'initialization' stamp: 'lr 4/13/2005 07:38'!
setValue: aBoolean
	value := aBoolean! !

!MAConstantRelation methodsFor: 'accessing' stamp: 'lr 4/13/2005 07:38'!
value
	^value! !

MABasicRelation subclass: #MASelectorRelation
	instanceVariableNames: 'selector arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MASelectorRelation class methodsFor: 'testing' stamp: 'lr 4/14/2005 13:26'!
isAbstract
	^false! !

!MASelectorRelation class methodsFor: 'conveniance' stamp: 'lr 4/13/2005 21:32'!
selector: aSelector
	^self selector: aSelector arguments: Array new.! !

!MASelectorRelation class methodsFor: 'instance creation' stamp: 'lr 4/13/2005 21:12'!
selector: aSelector arguments: aCollection
	^self new
		setSelector: aSelector;
		setArguments: aCollection;
		yourself.! !

!MASelectorRelation class methodsFor: 'conveniance' stamp: 'lr 4/13/2005 21:32'!
selector: aSelector with: anObject
	^self selector: aSelector arguments: (Array with: anObject).! !

!MASelectorRelation class methodsFor: 'conveniance' stamp: 'lr 4/13/2005 21:32'!
selector: aSelector with: aFirstObject with: aSecondObject
	^self selector: aSelector arguments: (Array with: aFirstObject with: aSecondObject).! !

!MASelectorRelation methodsFor: 'accessing' stamp: 'lr 4/13/2005 21:12'!
arguments
	^arguments! !

!MASelectorRelation methodsFor: 'testing' stamp: 'lr 4/13/2005 21:14'!
isSatisfiedBy: anObject
	^anObject perform: self selector withArguments: self arguments.! !

!MASelectorRelation methodsFor: 'accessing' stamp: 'lr 4/13/2005 21:12'!
selector
	^selector! !

!MASelectorRelation methodsFor: 'initialization' stamp: 'lr 4/13/2005 21:12'!
setArguments: aCollection
	arguments := aCollection! !

!MASelectorRelation methodsFor: 'initialization' stamp: 'lr 4/13/2005 21:13'!
setSelector: aSelector
	selector := aSelector! !

MARelation subclass: #MAComposedRelation
	instanceVariableNames: 'relations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

MAComposedRelation subclass: #MAAllRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MAAllRelation class methodsFor: 'testing' stamp: 'lr 4/9/2005 16:12'!
isAbstract
	^false! !

!MAAllRelation methodsFor: 'operators' stamp: 'lr 4/9/2005 18:07'!
& aRelation
	^self copyWith: aRelation.! !

!MAAllRelation methodsFor: 'testing' stamp: 'lr 4/9/2005 17:36'!
isSatisfiedBy: anObject
	^self relations allSatisfy: [ :each | 
		each isSatisfiedBy: anObject ].! !

MAComposedRelation subclass: #MAAnyRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MAAnyRelation class methodsFor: 'testing' stamp: 'lr 4/9/2005 16:12'!
isAbstract
	^false! !

!MAAnyRelation methodsFor: 'testing' stamp: 'lr 4/9/2005 17:36'!
isSatisfiedBy: anObject
	^self relations anySatisfy: [ :each | 
		each isSatisfiedBy: anObject ].! !

!MAAnyRelation methodsFor: 'operators' stamp: 'lr 4/9/2005 18:07'!
| aRelation
	^self copyWith: aRelation.! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 4/12/2005 21:58'!
new
	^super new
		setRelations: Array new;
		yourself.! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 4/9/2005 18:06'!
with: aRelation
	^self withAll: (Array with: aRelation).! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 4/9/2005 18:06'!
with: aFirstRelation with: aSecondRelation
	^self withAll: (Array with: aFirstRelation with: aSecondRelation).! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 4/12/2005 21:57'!
withAll: anArray
	^self new
		setRelations: anArray;
		yourself.! !

!MAComposedRelation methodsFor: 'copying' stamp: 'lr 4/9/2005 18:05'!
copyWith: aRelation
	^self class withAll: (self relations copyWith: aRelation).! !

!MAComposedRelation methodsFor: 'accessing' stamp: 'lr 4/9/2005 17:35'!
relations
	^relations! !

!MAComposedRelation methodsFor: 'initialization' stamp: 'lr 4/12/2005 21:54'!
setRelations: aCollection
	relations := aCollection! !

MAComposedRelation subclass: #MANoneRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MANoneRelation class methodsFor: 'testing' stamp: 'lr 4/12/2005 22:02'!
isAbstract
	^false! !

!MANoneRelation methodsFor: 'operators' stamp: 'lr 4/12/2005 22:21'!
!! aRelation
	^self copyWith: aRelation.! !

!MANoneRelation methodsFor: 'testing' stamp: 'lr 4/9/2005 17:38'!
isSatisfiedBy: anObject
	^self relations noneSatisfy: [ :each | 
		each isSatisfiedBy: anObject ].! !

!MARelation methodsFor: 'operators-binary' stamp: 'lr 4/12/2005 22:15'!
!! aRelation
	^MANoneRelation with: self with: aRelation.! !

!MARelation methodsFor: 'operators-binary' stamp: 'lr 4/9/2005 17:34'!
& aRelation
	^MAAllRelation with: self with: aRelation.! !

!MARelation methodsFor: 'testing' stamp: 'lr 4/14/2005 13:24'!
isSatisfiedBy: anObject
	self subclassResponsibility.! !

!MARelation methodsFor: 'operators-unary' stamp: 'lr 4/12/2005 22:18'!
not
	^MANoneRelation with: self.! !

!MARelation methodsFor: 'operators-binary' stamp: 'lr 4/9/2005 17:34'!
| aRelation
	^MAAnyRelation with: self with: aRelation.! !

Object subclass: #MAScaffolder
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAScaffolder subclass: #MADescribedScaffolder
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MADescribedScaffolder methodsFor: 'accessing' stamp: 'lr 4/4/2005 10:20'!
description
	^description! !

!MADescribedScaffolder methodsFor: 'accessing' stamp: 'lr 4/4/2005 10:21'!
description: aDescription
	description := aDescription! !

!MADescribedScaffolder methodsFor: 'initialization' stamp: 'lr 4/4/2005 10:22'!
initialize
	super initialize.
	self description: self class defaultContainer.! !

!MAScaffolder class methodsFor: 'instance creation' stamp: 'lr 3/28/2005 22:44'!
description: aDescription
	^self new
		description: aDescription;
		yourself.! !

!MAScaffolder methodsFor: 'initialization' stamp: 'lr 4/4/2005 10:21'!
initialize
	super initialize.
	self values: IdentityDictionary new.! !

!MAScaffolder methodsFor: 'private' stamp: 'lr 4/11/2005 11:34'!
readUsing: aDescription
	^aDescription isContainer
		ifTrue: [ super readUsing: aDescription ]
		ifFalse: [ 
			self values 
				at: aDescription
				ifAbsentPut: [ aDescription default ] ].! !

!MAScaffolder methodsFor: 'accessing' stamp: 'lr 3/21/2005 19:30'!
values
	^values! !

!MAScaffolder methodsFor: 'accessing' stamp: 'lr 3/21/2005 19:30'!
values: aDictionary
	values := aDictionary! !

!MAScaffolder methodsFor: 'private' stamp: 'lr 4/6/2005 23:16'!
write: anObject using: aDescription
	^aDescription isContainer
		ifTrue: [ super write: anObject using: aDescription ]
		ifFalse: [ 
			self values 
				at: aDescription
				put: anObject ].! !

Object subclass: #MAVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAVisitor subclass: #MAStreamer
	instanceVariableNames: 'stream objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAStreamer subclass: #MAReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MAReader methodsFor: 'streaming' stamp: 'lr 4/14/2005 13:19'!
next
	self subclassResponsibility.! !

MAReader subclass: #MAStReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MAStreamer class methodsFor: 'instance creation' stamp: 'lr 3/19/2005 12:33'!
on: aStream
	^self new
		setStream: aStream;
		yourself.! !

!MAStreamer methodsFor: 'accessing' stamp: 'lr 4/9/2005 14:19'!
id
	^objects last key.! !

!MAStreamer methodsFor: 'initialization' stamp: 'lr 4/9/2005 13:21'!
initialize
	super initialize.
	objects := OrderedCollection new.! !

!MAStreamer methodsFor: 'accessing' stamp: 'lr 4/9/2005 14:18'!
object
	^objects last value.! !

!MAStreamer methodsFor: 'initialization' stamp: 'lr 3/19/2005 13:01'!
setStream: aStream
	stream := aStream! !

!MAStreamer methodsFor: 'accessing' stamp: 'lr 3/19/2005 12:59'!
stream
	^stream! !

!MAStreamer methodsFor: 'visiting' stamp: 'lr 4/9/2005 14:19'!
visit: aFirstObject with: aSecondObject
	objects addLast: self nextId -> aSecondObject.
	[ self visit: aFirstObject ]
		ensure: [ objects removeLast ].! !

MAStreamer subclass: #MAWriter
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAWriter subclass: #MAStWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MAWriter methodsFor: 'initialization' stamp: 'lr 4/9/2005 14:16'!
initialize
	super initialize.
	id := 0.! !

!MAWriter methodsFor: 'private' stamp: 'lr 4/9/2005 14:19'!
nextId
	^ 't' , (id := id + 1) asString.! !

!MAWriter methodsFor: 'streaming' stamp: 'lr 4/9/2005 13:28'!
nextPut: anObject
	self nextPut: anObject using: anObject description.! !

!MAWriter methodsFor: 'streaming' stamp: 'lr 4/9/2005 13:19'!
nextPut: anObject using: aDescription
	self visit: aDescription with: anObject.! !

!MAWriter methodsFor: 'visiting-accessors' stamp: 'lr 4/9/2005 14:26'!
visitBlockAccessor: anAccessor
	self stream 
		nextPutAll: anAccessor writeBlock decompile allButFirst allButLast; space; 
		nextPutAll: ' value: '; nextPutAll: self id;
		nextPutAll: ' value: '; nextPutAll: self id;
		nextPutAll: '.'; cr.! !

!MAWriter methodsFor: 'visiting-accessors' stamp: 'lr 4/9/2005 14:05'!
visitCacadeAccessor: anAccessor
	self visit: anAccessor accessor.
	self visit: anAccessor next.! !

!MAWriter methodsFor: 'visiting-descriptions' stamp: 'lr 4/9/2005 14:20'!
visitContainer: aDescription
	self stream nextPutAll: self id; nextPutAll: ' := '; nextPutAll: self object class name; nextPutAll: ' basicNew.'; cr.
	aDescription do: [ :each | 
		each isPersistent ifTrue: [
			self 
				visit: each
				with: (each accessor read: self object) ] ].! !

!MAWriter methodsFor: 'visiting-descriptions' stamp: 'lr 4/9/2005 14:56'!
visitElement: aDescription
	self stream 
		nextPutAll: self id; 
		nextPutAll: ' := '; 
		nextPutAll: aDescription class name; 
		nextPutAll: ' basicNew parseString: ';
		print: (aDescription toString: self object);
		nextPutAll: '.';
		cr.
	self nextPut: aDescription.
	self stream 
		nextPutAll: (aDescription accessor printWrite: self id to: objects allButLast last key);
		cr.! !

!MAWriter methodsFor: 'visiting-accessors' stamp: 'lr 4/9/2005 14:08'!
visitModelAccessor: anAccessor
	self error: anAccessor asString , ' is not implemented.'
	! !

!MAWriter methodsFor: 'visiting-accessors' stamp: 'lr 4/9/2005 13:52'!
visitSelectorAccessor: anAccessor
	self stream nextPutAll: anAccessor writeSelector; space.! !

!MAVisitor methodsFor: 'visiting' stamp: 'lr 4/9/2005 13:06'!
visit: anObject
	anObject acceptMagritte: self.! !

!MAVisitor methodsFor: 'visiting-descriptions' stamp: 'lr 4/9/2005 13:33'!
visitContainer: anObject
	self visitDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-descriptions' stamp: 'lr 4/9/2005 13:21'!
visitDescription: anObject! !

!MAVisitor methodsFor: 'visiting-descriptions' stamp: 'lr 4/9/2005 13:22'!
visitElement: anObject
	self visitDescription: anObject.! !

!Object class methodsFor: '*Magritte-Core-converting' stamp: 'lr 4/4/2005 18:30'!
asLabel
	^self name! !

!Object class methodsFor: '*Magritte-Core-defaults' stamp: 'lr 4/4/2005 18:31'!
defaultContainer
	"Return the default description container."
	
	^MAPriorityContainer new 
		label: self asLabel;
		yourself.! !

!Object class methodsFor: '*Magritte-Core-accessing' stamp: 'lr 4/5/2005 20:09'!
description
	^MACachedBuilder default build: self.! !

!Object methodsFor: '*Magritte-Core-converting' stamp: 'lr 3/10/2005 22:20'!
asLabel
	^self asString.! !

!Object methodsFor: '*Magritte-Core-defaults' stamp: 'lr 4/12/2005 13:54'!
defaultWrapperClass
	^(Smalltalk includesKey: #MAOmniWrapper)
		ifFalse: [ MACheckedWrapper ]
		ifTrue: [
			self isODBPersistent 
				ifTrue: [ MAOmniWrapper ] 
				ifFalse: [ MACheckedWrapper ] ].! !

!Object methodsFor: '*Magritte-Core-accessing' stamp: 'lr 3/9/2005 22:24'!
description
	"Return the description of the reciever. Subclasses might override this message to return instance-based descriptions."
	
	^self class description.! !

!Object methodsFor: '*Magritte-Core-testing' stamp: 'lr 4/9/2005 12:35'!
isDescription
	^false! !

!Object methodsFor: '*Magritte-Core-model' stamp: 'lr 4/4/2005 17:33'!
readUsing: aDescription
	"Dispatch the read-access to the receiver using the accessor of aDescription."

	^aDescription accessor read: self.! !

!Object methodsFor: '*Magritte-Core-model' stamp: 'lr 4/4/2005 17:33'!
write: anObject using: aDescription
	"Dispatch the write-access to the receiver of anObject using the accessor of aDescription."

	aDescription accessor write: anObject to: self.! !

!False methodsFor: '*Magritte-Core-converting' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'no'! !

!Integer methodsFor: '*Magritte-Core-converting' stamp: 'lr 4/4/2005 21:18'!
asFileSize
	#( 'B' 'KB' 'MB' 'GB' 'TB' 'PB' 'EB' 'ZB' 'YB' )
		inject: self
		into: [ :value :each |
			value < 1024
				ifFalse: [ value // 1024 ]
				ifTrue: [ ^value asString , ' ' , each ] ].! !

Notification subclass: #MANotification
	instanceVariableNames: 'wrapper when'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

MANotification subclass: #MACommitNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

!MANotification class methodsFor: 'accessing-defaults' stamp: 'lr 4/9/2005 15:20'!
afterToken
	^ #after! !

!MANotification class methodsFor: 'accessing-defaults' stamp: 'lr 4/9/2005 15:20'!
beforeToken
	^ #before! !

!MANotification class methodsFor: 'instance creation' stamp: 'lr 4/9/2005 15:21'!
notifyAfter: aWrapper
	^self wrapper: aWrapper when: self afterToken.! !

!MANotification class methodsFor: 'instance creation' stamp: 'lr 4/9/2005 15:21'!
notifyBefore: aWrapper
	^self wrapper: aWrapper when: self beforeToken! !

!MANotification class methodsFor: 'instance creation' stamp: 'lr 4/9/2005 15:21'!
wrapper: aWrapper when: aSelector
	^self new
		wrapper: aWrapper;
		when: aSelector;
		signal.! !

!MANotification methodsFor: 'accessing-dynamic' stamp: 'lr 4/8/2005 08:21'!
accessor
	^self wrapper accessor.! !

!MANotification methodsFor: 'accessing-dynamic' stamp: 'lr 4/9/2005 00:37'!
description
	^self wrapper owner.! !

!MANotification methodsFor: 'testing' stamp: 'lr 4/9/2005 15:22'!
isAfter
	^self when = self class afterToken.! !

!MANotification methodsFor: 'testing' stamp: 'lr 4/9/2005 15:22'!
isBefore
	^self when = self class beforeToken.! !

!MANotification methodsFor: 'accessing' stamp: 'lr 4/9/2005 15:19'!
when
	^when! !

!MANotification methodsFor: 'accessing' stamp: 'lr 4/9/2005 15:19'!
when: aSymbol
	when := aSymbol! !

!MANotification methodsFor: 'accessing' stamp: 'lr 4/8/2005 08:21'!
wrapper
	^wrapper! !

!MANotification methodsFor: 'accessing' stamp: 'lr 4/8/2005 08:21'!
wrapper: aWrapper
	wrapper := aWrapper! !

MANotification subclass: #MAResetNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

MANotification subclass: #MAValidateNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

!True methodsFor: '*Magritte-Core-converting' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'yes'! !
MAConstantRelation initialize!
